clear
capture log close
set mem 500m
set more off


**** This code processes the British Patent Classification Data into stata
**** To run this code, simply replace with first global with your filepath 
**** It is also necessrary to add a temporary file, called temp, which is reached
**** using the filepath on the patenttemp global. This file can later be deleted.
**** Author: William Walker Hanlon
**** Date: February 9, 2016
**** If you find errors please contact: walker.hanlon@gmail.com


*** Laptop globals
global patent "C:\Users\Hanlon\Dropbox\British_patent_data\patent_abstracts_data\prepared"

global patentinput "$patent\entered_data\"
global patentoutput "$patent\output"
global patenttemp "$patent\temp"


*** Insheet and prepare patent data files
do "$patent\processing_code\process_patent_data_1_30"

do "$patent\processing_code\process_patent_data_31_60"

do "$patent\processing_code\process_patent_data_61_90"

do "$patent\processing_code\process_patent_data_91_120"

do "$patent\processing_code\process_patent_data_121_146"



*** Append patent files from various years


use "$patenttemp\patent_master_1_30", clear

append using "$patenttemp\patent_master_31_60"

append using "$patenttemp\patent_master_61_90"

append using "$patenttemp\patent_master_91_120"

append using "$patenttemp\patent_master_121_146"

drop v


**** Trim patent number and destring variables

replace patent_no=trim(patent_no)
destring year patent_no group, replace


***** Drop duplicate entries

duplicates report
duplicates drop

drop if year>83

*** Merge in group names
sort group
merge group using "$patent\processing_code\group_names"
tab _merge
drop _merge

rename class class_name
rename group class
sort class year patent_no

save "$patentoutput\patent_classification_database", replace


***
